local drawManager = {}
local drawBuffer = {}

function drawManager.clear() drawBuffer = {} end

function drawManager.bufferDrawEntity(x, y, drawFunction, zIndex)
    table.insert(drawBuffer,
                 {x = x, y = y, zIndex = zIndex or 0, draw = drawFunction})
end

function drawManager.update(dt) end

function drawManager.draw()
    table.sort(drawBuffer, function(a, b)
        if a.zIndex == b.zIndex then
            return a.y < b.y
        else
            return a.zIndex < b.zIndex
        end
    end)
    for _, entity in ipairs(drawBuffer) do entity.draw() end
    drawManager.clear()
end

return drawManager
