local sdk = require "sdk.sdk"
local camera = require "camera"
local config = require "config"
local drawManager = require "drawManager"

local Spawner = {}
Spawner.__index = Spawner

function Spawner:new()
    local self = setmetatable({}, Spawner)
    self.typeCount = {}
    self.wave = 0
    self.waveReady = true
    self.waveCooldown = 0
    return self
end

function Spawner:update(data)
    self.wave = data.wave
    self.waveReady = data.waveReady
    self.waveCooldown = data.waveCooldown
    self.typeCount = data.typeCount
end

local spawnerInstance = Spawner:new()

setmetatable(spawnerInstance, {__index = function(t, k) return Spawner[k] end})

return spawnerInstance
